#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define F first
#define S second
typedef long long ll;
const bool MULTITEST = 0;

struct segtree {

    ll n;
    vector<ll> t;

    segtree (ll sz){
        n = 1;
        while(n < sz) n *= 2;
        t.resize(2 * n);
        n = sz;
    }

    void set(ll ind){
        set(ind, ind + 1, 0, n, 0);
    }

    void set(ll ql, ll qr, ll l, ll r, ll v){
        if(r <= ql || qr <= l) return;
        if(ql <= l && r <= qr){
            t[v] = 1;
            return;
        }
        ll mid = (l + r) / 2;
        set(ql, qr, l, mid, v * 2 + 1);
        set(ql, qr, mid, r, v * 2 + 2);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    ll get(ll l, ll r){
        return get(l, r + 1, 0, n, 0);
    }

    ll get(ll ql, ll qr, ll l, ll r, ll v){
        if(r <= ql || qr <= l) return 0;
        if(ql <= l && r <= qr){
            return t[v];
        }
        ll mid = (l + r) / 2;
        ll left = get(ql, qr, l, mid, v * 2 + 1);
        ll right = get(ql, qr, mid, r, v * 2 + 2);
        return left + right;
    }
};

ll solve() {
    ll q;
    cin >> q;
    ll sz = 0;
    vector<ll> l (q, -1), r (q, -1), ans (q);
    vector<pair<ll, ll>> qs, adds;
    for(ll tt = 0; tt < q; tt ++){
        ll t;
        cin >> t;
        if(t == 1){
            ll x;
            cin >> x;
            sz ++;
            adds.push_back({x, sz});
        } else {
            ll st, end, v;
            cin >> st >> end >> v;
            l[tt] = st;
            r[tt] = end;
            qs.push_back({v, tt});
        }
    }
    sort(all(adds));
    sort(all(qs));
    ll cur = -1;
    segtree tree (sz);
    for(ll i = 0; i < qs.size(); i ++){
        ll vi = qs[i].F, ind = qs[i].S;
        while(cur + 1 < adds.size() && adds[cur + 1].F <= vi){
            cur ++;
            tree.set(adds[cur].S - 1);
        }
        ll g = tree.get(l[ind] - 1, r[ind] - 1);
        ans[ind] = g;
    }
    for(ll i = 0; i < q; i ++){
        if(l[i] != -1){
            cout << ans[i] << "\n";
        }
    }
    return 0;
}


int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll tt = 1;
    if (MULTITEST) cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}